#include <stdio.h>
#include <string>
#include <windows.h>
#include "optimized_string/string.h"

void main()
{
	optimized_string::String String("blabla");
	optimized_string::String Other1("blabla");
	optimized_string::String Other2("blabla1");
	if (String == "blabla") printf("OK!\n");
	if (!(String == "blabla1")) printf("OK!\n");
	if (String == Other1) printf("OK!\n");
	if (!(String == Other2)) printf("OK!\n");

	String = "  blabla\n\n\n";
	printf("%s\n", String.GetCString());
	String.LTrim(); 
	printf("%s\n", String.GetCString());
	String.RTrim();
	printf("%s\n", String.GetCString());

	LONGLONG Start;
	LONGLONG Stop;
	LONGLONG Delta;
	LONGLONG Frequency;

	double dDelta;
	double dTime;
	double dFrequency;

	printf("-- optimized string --\n");
	QueryPerformanceCounter((LARGE_INTEGER*)&Start);

	for (int i = 0; i < 2; i++)
	{
		optimized_string::String str("blabla");
		optimized_string::String strCompare("blablaaaaaa");

		for (int i = 0; i < 60000; i++)
		{
			str.Append("a");

			if (str.Compare(strCompare))
				printf("Equals\n");;
		}
	}

	QueryPerformanceCounter((LARGE_INTEGER*)&Stop);
	QueryPerformanceFrequency((LARGE_INTEGER*)&Frequency);

	Delta = Stop - Start;
	dDelta = (double)Delta;
	dFrequency = (double)Frequency;
	dTime = dDelta / dFrequency;

	printf("optimized string: %f ms\n", dTime * 1000);

	printf("-- std::string --\n");
	QueryPerformanceCounter((LARGE_INTEGER*)&Start);

	std::string strHallo;
	std::string strHallo2("1234567890 1234567890");
	for (int i = 0; i < 2; i++)
	{
		std::string str("blabla");
		std::string strCompare("blablaaaaaa");

		for (int i = 0; i < 60000; i++)
		{
			str.append("a");

			if (str == strCompare)
				printf("Equals\n");;
		}
	}

	QueryPerformanceCounter((LARGE_INTEGER*)&Stop);
	QueryPerformanceFrequency((LARGE_INTEGER*)&Frequency);

	Delta = Stop - Start;
	dDelta = (double)Delta;
	dFrequency = (double)Frequency;
	dTime = dDelta / dFrequency;

	printf("std::string: %f ms\n", dTime * 1000);
}