#ifndef PASCALSTRING_H
#define PASCALSTRING_H

#include <memory.h>
#include <string.h>

namespace optimized_string
{

class PascalString
{
public:
	enum 
	{
		DEFAULT_ALLOC_SIZE = 128,
		DEFAULT_GROW_SIZE = 128,
		MAX_LENGTH = 65535,
	};

public:
	// constructor / destructor
	PascalString();
	PascalString(const PascalString& strOther);
	PascalString(const char* szString, const size_t& Length);
	~PascalString();

	// set / reset
	void Reset();
	void Set(const PascalString& Other);
	void Set(const char* szString, const unsigned short usLength);

	// basic string functionality
	void Append(const PascalString& Other, const size_t& Length);
	void Append(const char* szString, const size_t& Length);
	const bool Compare(const PascalString& Other) const;
	const bool Compare(const char* szString, const size_t& Length) const;
	void LTrim();
	void RTrim();
	size_t Len();
	const size_t Len() const;
	char* GetString();
	const char* GetString() const;
	const char* GetCString();

protected:
	void _Allocate(unsigned short usLength);
	void _CheckGrow(unsigned short usLength);

protected:
	unsigned short m_usLength;
	char* m_szString;
	unsigned short m_usBufferLength;
};

};

#endif // PASCALSTRING_H